unit Unit1;
 
interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls,
  ShellApi, registry;

const
  RegKey = 'SOFTWARE\GetSizer\Options';  

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    ListBox1: TListBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Label2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    procedure WMDROPFILES(var Mes: TWMDROPFILES);message WM_DROPFILES;
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);message WM_GETMINMAXINFO;
  public
    procedure GetSelected;
    procedure Count;
  end;

  item = record
   size:int64;
   name:string;
  end;

var
  Form1: TForm1;
  INIReg: TRegInifile;
  mode: byte;
  items:array of item;
  sel: array of integer;

implementation 

{$R *.DFM}

procedure TForm1.WMDROPFILES(var Mes: TWMDROPFILES);
 var Num,i:longint;
     buffer:array[0..500] of char;
     HF:thandle;
     HW,LW:cardinal;
begin
 listbox1.Clear;
 Num:=DragQueryFile(Mes.Drop,$FFFFFFFF,nil,0);
 setlength(items,Num);
 for i:=0 to (Num-1) do begin
  DragQueryFile(Mes.Drop,i,@buffer,sizeof(buffer));
  items[i].name:=buffer;
  HF:=CreateFile(buffer,GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  if hf<>INVALID_HANDLE_VALUE then begin
   LW:=getfilesize(HF,@HW);
   items[i].size:=LW+HW*4294967296;
  end else items[i].size:=0;
  CloseHandle(HF);
  if checkbox1.Checked then listbox1.Items.Add(buffer) else listbox1.Items.Add(extractfilename(buffer));
 end;
 listbox1.SelectAll;
 GetSelected;
 Count;
end; 

procedure TForm1.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
 Msg.MinMaxInfo^.ptMinTrackSize:=Point(236, 230);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin        
 edit1.DoubleBuffered:=true;
 DragAcceptFiles(Form1.Handle, True);
 INIReg:=TRegInifile.Create;
 form1.Width:=INIReg.ReadInteger(RegKey,'WinWidth',424);
 form1.Height:=INIReg.ReadInteger(RegKey,'WinHeight',253);
 form1.Top:=INIReg.ReadInteger(RegKey,'WinTop',(GetSystemMetrics(SM_CYSCREEN)-form1.height) div 2);
 form1.Left:=INIReg.ReadInteger(RegKey,'WinLeft',(GetSystemMetrics(SM_CXSCREEN)-form1.Width) div 2);
 if INIReg.ReadBool(RegKey,'WinState',false) then form1.WindowState:=wsmaximized;
 checkbox1.Checked:=INIReg.ReadBool(RegKey,'FullPath',false);
 mode:=INIReg.ReadInteger(RegKey,'Mode',3);
 INIReg.CloseKey;
 INIReg.Free;
 case mode of
 1:radiobutton1.Checked:=true;
 2:radiobutton2.Checked:=true;
 3:radiobutton3.Checked:=true;
 4:radiobutton4.Checked:=true;
 5:radiobutton5.Checked:=true;
 end;
 label2.Caption:=''+#13+#10+'';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 INIReg:=TRegInifile.Create;
 if form1.WindowState=wsmaximized then INIReg.WriteBool(RegKey,'WinState',true) else begin
  INIReg.WriteBool(RegKey,'WinState',false);
  INIReg.WriteInteger(RegKey,'WinTop',form1.Top);
  INIReg.WriteInteger(RegKey,'WinLeft',form1.Left);
  INIReg.WriteInteger(RegKey,'WinWidth',form1.Width);
  INIReg.WriteInteger(RegKey,'WinHeight',form1.Height);
 end;
 INIReg.WriteInteger(RegKey,'Mode',mode);
 INIReg.WriteBool(RegKey,'FullPath',checkbox1.Checked);
 INIReg.CloseKey;
 INIReg.Free;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
 checkbox1.Checked:=not(checkbox1.Checked);
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
 if radiobutton1.Checked then mode:=1;
 if radiobutton2.Checked then mode:=2;
 if radiobutton3.Checked then mode:=3;
 if radiobutton4.Checked then mode:=4;
 if radiobutton5.Checked then mode:=5;
 Count;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
 var i:integer;
begin
 if items<>nil then begin
  GetSelected;
  if CheckBox1.Checked then
   for i:=0 to high(items) do listbox1.Items.Strings[i]:=items[i].name
  else
   for i:=0 to high(items) do listbox1.Items.Strings[i]:=extractfilename(items[i].name);
  for i:=0 to high(sel) do listbox1.Selected[sel[i]]:=true;
 end;
end;

procedure TForm1.GetSelected;
 var i,j:integer;
begin
 i:=0;
 setlength(sel,listbox1.SelCount);
 for j:=0 to listbox1.Count-1 do if listbox1.Selected[j] then begin
  sel[i]:=j;
  inc(i);
 end;
end;

procedure TForm1.Count;
 var sum:int64;
     i:integer;
     res:string;
begin
 sum:=0;
 for i:=0 to high(sel) do sum:=sum+items[sel[i]].size;
 case mode of
 1:res:=inttostr(sum*8);
 2:res:=inttostr(sum);
 3:res:=floattostr(sum/1024);
 4:res:=floattostr(sum/1048576);
 5:res:=floattostr(sum/1073741824);
 end;
 if sel<>nil then edit1.Text:=res else edit1.Text:='';
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
 GetSelected;
 Count;
end;

end.
